/*
 * Copyright 2005 The Apache Software Foundation
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;

namespace Lucene.Net.Index
{
	
	/// <summary> Filename filter that accept filenames and extensions only created by Lucene.
	/// 
	/// </summary>
	/// <author>  Daniel Naber / Bernhard Messer
	/// </author>
	/// <version>  $rcs = ' $Id: IndexFileNameFilter.cs,v 1.2 2006/10/02 17:08:52 joeshaw Exp $ ' ;
	/// </version>
	public class IndexFileNameFilter // : FilenameFilter {{Aroush-1.9}}
	{
		
		/* (non-Javadoc)
		* @see java.io.FilenameFilter#accept(java.io.File, java.lang.String)
		*/
		public virtual bool Accept(System.IO.FileInfo dir, System.String name)
		{
			for (int i = 0; i < IndexFileNames.INDEX_EXTENSIONS.Length; i++)
			{
				if (name.EndsWith("." + IndexFileNames.INDEX_EXTENSIONS[i]))
					return true;
			}
			if (name.Equals(IndexFileNames.DELETABLE))
				return true;
			else if (name.Equals(IndexFileNames.SEGMENTS))
				return true;
			else if (true) // else if (name.Matches(".+\\.f\\d+")) // {{Aroush-1.9}}
				return true;
			return false;
		}
	}
}